﻿Public Class Form1
    Private Const Max_on_time As Integer = 23
    Private Const Min_on_time As Integer = 3
    Private Const Default_on_time As Integer = 13
    Private Const Max_off_time As Integer = 31
    Private Const Min_off_time As Integer = 12
    Private Const Default_off_time As Integer = 22
    Dim buf_read_index As Integer = 0
    Dim buf_read As String

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim send_text As String

        Label_Time.Text = Date.Now.ToString("yyyy/MM/dd HH:mm:ss")
        Label_Time.Visible = True

        If SerialPort1.IsOpen Then
            send_text = "$GPRMC," & Date.UtcNow.ToString("HHmmss") & ".00,,,,,,,," & Date.UtcNow.ToString("ddMMyy")
            Label_send_time.Text = send_text
            SerialPort1.WriteLine(send_text)
        End If
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Text = "NeonClock " & System.String.Format("V{0}.{1}.{2:00}", My.Application.Info.Version.Major, My.Application.Info.Version.Minor, My.Application.Info.Version.Build)

        TrackBar_brightness.Maximum = Max_on_time
        TrackBar_brightness.Minimum = Min_on_time
        TrackBar_brightness.Value = Default_on_time
        TrackBar_period.Maximum = Default_on_time + Max_off_time
        TrackBar_period.Minimum = Default_on_time + Min_off_time
        TrackBar_period.Value = Default_on_time + Default_off_time

        Label_brightness_value.Text = TrackBar_brightness.Value
        Label_period_value.Text = TrackBar_period.Value
        Label_Hz.Text = calc_Hz() & " Hz"

        If My.Computer.Ports.SerialPortNames.Count = 0 Then
            MsgBox("ネオン管時計が接続されていない" & vbCr & "接続してからプログラムを再起動", vbExclamation, "ERROR")
            Exit Sub
        Else
            For Each sp_name As String In My.Computer.Ports.SerialPortNames
                ListBox1.Items.Add(sp_name)
            Next
        End If

    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        Const QUERY As String = "$#?"

        SerialPort1.PortName = ListBox1.SelectedItem
        Try
            SerialPort1.Open()
            SerialPort1.WriteLine(QUERY)
            Label_send_setup.Text = QUERY
            Button_alarm.Enabled = True
            TrackBar_brightness.Enabled = True
            TrackBar_period.Enabled = True
            Button_down.Enabled = True
            Button_up.Enabled = True
            DateTimePicker1.Enabled = True
            RadioButton_OFF.Enabled = True
            RadioButton_ON.Enabled = True
        Catch
            MsgBox("COMポート OPEN ERROR" & vbCr & "たぶんネオン管時計ではないものを選択した", vbExclamation, "ERROR")
            Exit Sub
        End Try
    End Sub

    Private Sub trackbar_update()
        Label_brightness_value.Text = TrackBar_brightness.Value
        TrackBar_period.Maximum = Max_off_time + TrackBar_brightness.Value
        TrackBar_period.Minimum = Min_off_time + TrackBar_brightness.Value
        Label_period_value.Text = TrackBar_period.Value
    End Sub

    Private Sub TrackBar_brightness_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar_brightness.Scroll
        trackbar_update()
    End Sub

    Private Sub TrackBar_period_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar_period.Scroll
        Label_period_value.Text = TrackBar_period.Value
        Label_Hz.Text = calc_Hz() & " Hz"
    End Sub

    Private Function calc_Hz() As Integer
        calc_Hz = CInt(250000 / (TrackBar_period.Value * 8))
    End Function

    Private Sub Button_alarm_Click(sender As System.Object, e As System.EventArgs) Handles Button_alarm.Click
        Dim alarm As String
        Dim off_time As Integer
        Dim sign_text As String
        Dim cal_val As Integer
        Dim crc As UShort

        Timer1.Stop()
        If RadioButton_ON.Checked Then
            alarm = "E"
        Else
            alarm = "D"
        End If
        off_time = TrackBar_period.Value - TrackBar_brightness.Value
        cal_val = TextBox_cal.Text
        If cal_val < 0 Then
            sign_text = "-"
            cal_val = -cal_val
        Else
            sign_text = "+"
        End If
        Label_send_setup.Text = "$#C" & TrackBar_brightness.Value.ToString("D2") & "," & off_time.ToString("D2") & "," &
                                DateTimePicker1.Value.ToString("HH:mm") & "," & alarm & "," &
                                sign_text & cal_val.ToString("D2")
        crc = crc16(&HFFFF, Label_send_setup.Text, 20)
        Label_send_setup.Text = Label_send_setup.Text & " " & crc.ToString("X4")
        SerialPort1.WriteLine(Label_send_setup.Text)
        Timer1.Start()
    End Sub

    Private Sub Button_up_Click(sender As System.Object, e As System.EventArgs) Handles Button_up.Click
        Dim val As Integer

        val = CInt(TextBox_cal.Text)
        If val <> 99 Then
            TextBox_cal.Text = val + 1
        End If
    End Sub

    Private Sub Button_down_Click(sender As System.Object, e As System.EventArgs) Handles Button_down.Click
        Dim val As Integer

        val = CInt(TextBox_cal.Text)
        If val <> -99 Then
            TextBox_cal.Text = val - 1
        End If

        DateTimePicker1.Value = "2000/1/1 7:00"
    End Sub

    Private Function crc16(crc As UShort, ByRef str As String, len As Integer)
        Const CRC_CCITT As UShort = &H8408
        Dim i As Integer
        Dim j As Integer

        crc = Not crc
        For i = 0 To len - 1
            crc = crc Xor Convert.ToUInt16(str(i))
            For j = 0 To 7
                If crc And 1 Then
                    crc = (crc >> 1) Xor CRC_CCITT
                Else
                    crc = crc >> 1
                End If
            Next j
        Next i

        crc16 = Not crc
    End Function

    Delegate Sub setupDelegate(ByVal str As String)
    Private Sub neonclocksetup(ByVal str As String)
        Dim cal_val As Integer

        Label_recieve_setup.Text = str
        TrackBar_brightness.Value = Integer.Parse(str(1)) * 10 + Integer.Parse(str(2))
        trackbar_update()
        Label_brightness_value.Text = TrackBar_brightness.Value
        TrackBar_period.Value = TrackBar_brightness.Value + Integer.Parse(str(4)) * 10 + Integer.Parse(str(5))
        Label_period_value.Text = TrackBar_period.Value
        DateTimePicker1.Value = "2000/1/1 " & str(7) & str(8) & str(9) & str(10) & str(11)
        If str(13) = "E" Then
            RadioButton_ON.Checked = True
            RadioButton_OFF.Checked = False
        Else
            RadioButton_ON.Checked = False
            RadioButton_OFF.Checked = True
        End If
        cal_val = Integer.Parse(str(16)) * 10 + Integer.Parse(str(17))
        If str(15) = "-" Then
            cal_val = -cal_val
        End If
        TextBox_cal.Text = cal_val
    End Sub

    Private Sub SerialPort1_DataReceived(sender As System.Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim rbytes As Integer
        Dim tmp_char As Char

        Dim crcPC As UShort
        Dim crcHW As UShort
        Dim crc_string As String

        Dim setupMethod As New setupDelegate(AddressOf neonclocksetup)
        Try
            rbytes = SerialPort1.BytesToRead
            While rbytes > 0 And SerialPort1.IsOpen
                tmp_char = Chr(SerialPort1.ReadByte)
                Select Case tmp_char
                    Case vbCr
                        buf_read_index = 0
                    Case vbLf
                        buf_read_index = 0
                        crcPC = crc16(&HFFFF, buf_read, 18)
                        crc_string = buf_read(19) & buf_read(20) & buf_read(21) & buf_read(22)
                        crcHW = Convert.ToUInt16(crc_string, 16)
                        If crcPC <> crcHW Then
                            MsgBox("CRCチェックサム通信エラー " & vbCr & "通信が途中で途切れたもしくはノイズ" & vbCr & "再起動してやり直す", vbExclamation, "ERROR")
                        Else
                            If buf_read(0) = "R" Then
                                Label_recieve_setup.Invoke(setupMethod, buf_read)
                            End If
                        End If
                    Case Else
                        buf_read = buf_read & tmp_char
                        buf_read_index = buf_read_index + 1
                End Select
            End While
        Catch ex As System.IO.IOException
            Application.Exit()
        End Try
    End Sub

    Private Sub Form1_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If
    End Sub
End Class
